build.sh 9.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238
  1. #!/bin/bash
  2. # (c) 2014-2015 Freifunk Paderborn <maschinenraum@paderborn.freifunk.net>
  3. #
  4. # This script builds the firmware by the environment variables given, the
  5. # first two being mandatory:
  6. #
  7. # BASE = Gluon Version (tag or commit, i.e. v2014.4)
  8. # BRANCH = Firmware Branch (stable/testing/experimental)
  9. # SITE = site repository to use
  10. # SITE_ID = specific site repository commit-id (leave blank to use HEAD)
  11. # VERSION = the version tag (can only be empty if BRANCH=experimental)
  12. # BUILD_TS = build timestamp (format: %Y-%m-%d %H:%M:%S)
  13. # BROKEN = 0 (default) or 1, build the untested hardware model firmwares, too
  14. # MAKEJOBS = number of compiler processes running in parallel (default: number of CPUs/Cores)
  15. # TARGETS = a space separated list of target platforms (if unset, all platforms will be build)
  16. # PRIORITY = determines the number of day a rollout phase should last at most
  17. # VERBOSE = 0 (default) or 1, call the make commands with 'V=s' to see actual errors better
  18. # SITE_REPO_FETCH_METHOD = http, everything except "git" will use the HTTP method for fetchting site repo
  19. #
  20. function get_all_supported_platforms()
  21. {
  22. local buffer;
  23. for val in $(ls ${1}) ; do
  24. [ -d "./${1}/${val}" ] || continue
  25. buffer="${buffer} ${val}"
  26. done
  27. echo ${buffer}
  28. }
  29. if [ "_$BRANCH" == "_" ]; then
  30. echo "Please specify BRANCH environment variable." >&2
  31. exit 1
  32. fi
  33. if [ "_$BASE" == "_" ]; then
  34. echo "Please specify BASE environment variable (Gluon, i.e. 'v2014.3' or commit-id)." >&2
  35. exit 1
  36. fi
  37. if [ "${BRANCH}" != "experimental" -a "${BASE}" == "HEAD" ] ; then
  38. echo "HEAD is not an allowed BASE-identifier for non-experimental builds." >&2
  39. echo "Either use a tagged commit or the commit-SHA itself." >&2
  40. exit 1
  41. fi
  42. if [ "_$VERSION" == "_" -a "$BRANCH" != "experimental" ]; then
  43. echo "Please specify VERSION environment variable (not necessary for experimental branch)." >&2
  44. exit 1
  45. fi
  46. MY_DIR=$(dirname $0)
  47. MY_DIR=$(readlink -f "$MY_DIR")
  48. CODE_DIR="src"
  49. OUTPUT_DIR="${MY_DIR}/output"
  50. BUILD_INFO_FILENAME="build-info.txt"
  51. VERSIONS_INFO_DIR="versions"
  52. pushd $MY_DIR > /dev/null
  53. [ "_$BUILD_TS" == "_" ] && export BUILD_TS=$(date +"%Y-%m-%d %H:%M:%S")
  54. . functions.sh
  55. ### CHECK THAT VERSION DOES NOT YET EXISTS
  56. [ -n "$VERSION" -a -x "${VERSIONS_INFO_DIR}/${VERSION}" ] && abort "There exists a version file for '$VERSION' ... you are trying to do something really stupid, aren't you?"
  57. ### INIT /src IF NECESSARY
  58. if [ ! -d "$CODE_DIR" ]; then
  59. info "Code directory does not exist yet - fetching Gluon ..."
  60. git clone https://github.com/freifunk-gluon/gluon.git "$CODE_DIR"
  61. fi
  62. if [ "_${SITE_REPO_FETCH_METHOD}" != "_git" ]; then
  63. SITE_REPO_URL="https://git.c3pb.de/freifunk-pb/site-${SITE}.git"
  64. else
  65. SITE_REPO_URL="git@git.c3pb.de:freifunk-pb/site-${SITE}.git"
  66. fi
  67. ### INIT /src/site IF NECESSARY
  68. if [ -d "$CODE_DIR/site" ]; then
  69. # verify the site-repo is the correct one ($SITE), otherwise delete the repo
  70. pushd "$CODE_DIR/site"
  71. url=$(git remote show origin | awk '/Fetch URL/ { print $3; }')
  72. if [ "$SITE_REPO_URL" != "$url" ]; then
  73. info "The site repository is not the correct one."
  74. if ! git diff-index --quiet HEAD --; then
  75. popd > /dev/null
  76. abort "The site repo is the wrong one but has local modifications, please fix this manually."
  77. fi
  78. # check on the actual branch, not the target one given as parameter
  79. local_branch=$(git branch --list --no-color | awk '/^*/ { print $2; }')
  80. commits=$(git log origin/${local_branch}..HEAD)
  81. if [ -n "$commits" ]; then
  82. popd > /dev/null
  83. abort "The site repo is the wrong one but has unpushed commits, please fix this manually."
  84. fi
  85. # remove the directory without asking further questions
  86. popd > /dev/null
  87. rm -Rf "$CODE_DIR/site" || abort "Failed to remove wrong site-repository."
  88. success "Removed old site directory in order to be able to clone the correct one."
  89. else
  90. popd > /dev/null
  91. fi
  92. fi
  93. if [ ! -d "$CODE_DIR/site" ]; then
  94. info "Site repository does not exist, fetching it ..."
  95. git clone "$SITE_REPO_URL" "$CODE_DIR/site" || abort "Failed to fetch SITE repository."
  96. fi
  97. ### CHECKOUT GLUON
  98. progress "Checking out GLUON '$BASE' ..."
  99. cd $CODE_DIR
  100. # TODO: check if gluon got modified and bail out if necessary
  101. git fetch
  102. if [ "$BASE" = "master" ]; then
  103. git checkout -q origin/master
  104. else
  105. git checkout -q $BASE
  106. fi
  107. [ "$?" -eq "0" ] || abort "Failed to checkout '$BASE' gluon base version, mimimi." >&2
  108. GLUON_COMMIT=$(git rev-list --max-count=1 HEAD)
  109. ### CHECKOUT SITE REPO
  110. progress "Checking out SITE REPO ..."
  111. cd site
  112. # TODO: check if site got modified locally and bail out if necessary
  113. if [ "_${SITE_ID}" == "_" ]; then
  114. # no specific site given - get the most current one
  115. git checkout -q $BRANCH ; git pull
  116. [ "$?" -eq "0" ] || abort "Failed to get newest '$BRANCH' in site repository, mimimi."
  117. else
  118. # fetch site repo updates
  119. git fetch || true
  120. # commit given - use this one
  121. git checkout -q ${SITE_ID} || abort "Failed to checkout requested site commit, mimimi."
  122. fi
  123. SITE_COMMIT=$(git rev-list --max-count=1 HEAD)
  124. cd ..
  125. ### CLEAN
  126. if [ -d "./build/" -a "$BRANCH" != "experimental" ]; then
  127. progress "Cleaning your build environment ..."
  128. make dirclean
  129. fi
  130. ### PREPARE
  131. progress "Preparing the build environment (make update) ..."
  132. make update
  133. [ "$?" -eq "0" ] || abort "Failed to update the build environment, mimimi."
  134. # determine VERSION for BRANCH=experimental if it is not set
  135. if [ "${BRANCH}" == "experimental" -a -z "${VERSION}" ] ; then
  136. default_release_pattern=$( awk -F" := " '/^DEFAULT_GLUON_RELEASE/ { gsub("shell ", "", $2); print $2; }' ./site/site.mk )
  137. VERSION=$(eval echo ${default_release_pattern})
  138. info "EXPERIMENTAL FIRMWARE: using version tag '$VERSION'"
  139. fi
  140. # set reasonable defaults for unset environment variables
  141. [ -n "${BROKEN}" ] || BROKEN=0
  142. [ -n "${MAKEJOBS}" ] || MAKEJOBS=$(grep -c "^processor" /proc/cpuinfo)
  143. [ -n "${TARGETS}" ] || TARGETS=$(get_all_supported_platforms "./targets")
  144. [ -n "${PRIORITY}" ] || PRIORITY=0
  145. MAKE_PARAM=""
  146. [ "_$VERBOSE" = "_1" ] && MAKE_PARAM="${MAKE_PARAM} V=s"
  147. # we are now ready to produke the firmware images, so let's "save" our state
  148. build_info_path="${OUTPUT_DIR}/${BRANCH}/${BUILD_INFO_FILENAME}"
  149. progress "Saving build information to: ${build_info_path}"
  150. [ -n "${build_info_path}" -a -f "${build_info_path}" ] && rm -f ${build_info_path}
  151. mkdir -p $(dirname ${build_info_path})
  152. [ "$?" -eq "0" ] || abort "Unable to create output directory: $(dirname ${build_info_path})"
  153. touch $(dirname ${build_info_path})
  154. [ "$?" -eq "0" ] || abort "Cannot create build information file: ${build_info_path}"
  155. echo "VERSION=${VERSION}" >> ${build_info_path}
  156. echo "GLUON=${GLUON_COMMIT} # ${BASE}" >> ${build_info_path}
  157. echo "BRANCH=${BRANCH}" >> ${build_info_path}
  158. echo "SITE_REPO=${SITE}" >> ${build_info_path}
  159. echo "SITE=${SITE_COMMIT} # ${VERSION}" >> ${build_info_path}
  160. echo "TARGETS=${TARGETS}" >> ${build_info_path}
  161. echo "TS=${BUILD_TS}" >> ${build_info_path}
  162. ### BUILD FIRMWARE
  163. progress "Building the firmware - please stand by!"
  164. for target in ${TARGETS} ; do
  165. # configure build environment for our current target
  166. export GLUON_TARGET="${target}"
  167. gluon_build_env_vars="GLUON_TARGET=\"${target}\" GLUON_BRANCH=\"${BRANCH}\" GLUON_RELEASE=\"${VERSION}\" BROKEN=\"${BROKEN}\""
  168. # prepare build environment for our current target
  169. progress "Preparing build environment for target ${target}."
  170. [ "${BRANCH}" == "experimental" ] || make clean
  171. make -j ${MAKEJOBS} prepare-target${MAKE_PARAM}
  172. # need to have a toolchain for the particular target
  173. progress "Building toolchain for target ${target}."
  174. make -j ${MAKEJOBS} toolchain/install${MAKE_PARAM}
  175. [ "$?" -eq "0" ] || abort "Unable to build toolchain for target. Aborting."
  176. # now we can start building the images for the target platform
  177. progress "Building FFPB-flavoured Gluon firmware for target ${target}. You'd better go and fetch some c0ffee!"
  178. make_targets="prepare"
  179. eval "${gluon_build_env_vars} faketime \"$BUILD_TS\" make -j ${MAKEJOBS} ${make_targets}${MAKE_PARAM}"
  180. [ "$?" -eq "0" ] || abort "Failed to build firmware for target-platform ${target}."
  181. # finally compile the firmware binaries
  182. progress "Compiling binary firmware images."
  183. faketime "$BUILD_TS" make images${MAKE_PARAM}
  184. [ "$?" -eq "0" ] || abort "Failed to assemble images for target-platform ${target}."
  185. done
  186. cd ..
  187. # compress all binaries into 7z archive
  188. progress "Assembling images.7z ..."
  189. [ -e "${OUTPUT_DIR}/${BRANCH}/images.7z" ] && rm "${OUTPUT_DIR}/${BRANCH}/images.7z"
  190. 7z a "${OUTPUT_DIR}/${BRANCH}/images.7z" ${CODE_DIR}/images/sysupgrade/*.bin ${CODE_DIR}/images/factory/*.bin || abort "Failed to assemble images (did you install p7zip-full?)."
  191. # generate, franken-merge, and copy manifests
  192. progress "Generating and copying manifest ..."
  193. pushd $CODE_DIR
  194. GLUON_TARGET="ar71xx-generic" GLUON_BRANCH=$BRANCH make manifest || abort "Failed to generate the manifest, try running 'make manifest' in '$CODE_DIR' directory manually."
  195. popd
  196. cp "${CODE_DIR}/images/sysupgrade/${BRANCH}.manifest" "${OUTPUT_DIR}/${BRANCH}/"
  197. # Saving a copy of the build info file as reference
  198. progress "Building a greater and brighter firmware finished successfully. Saving build information at: ${VERSIONS_INFO_DIR}/${VERSION}"
  199. cp -p "${build_info_path}" "${VERSIONS_INFO_DIR}/${VERSION}"
  200. # The end. Finally.
  201. success "We're done, go and enjoy your new firmware in ${OUTPUT_DIR}/${BRANCH}!"
  202. popd > /dev/null